package pvc

import (
	"git.indie.host/controller-util/syncer"
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"
	"sigs.k8s.io/controller-runtime/pkg/controller/controllerutil"

	corev1 "k8s.io/api/core/v1"
)

type GenPVCFunc func(Conf) (*corev1.PersistentVolumeClaim, error)

type GenResourcesFunc func() (corev1.ResourceRequirements, error)
type GenAccessModesFunc func() ([]corev1.PersistentVolumeAccessMode, error)

type Instance interface {
	meta.Mutate
	interfaces.Object
	interfaces.Reconcile
	syncer.Interface
	MutateFn() controllerutil.MutateFn
	// GenPVCFunc() *corev1.PersistentVolumeClaim
}

type Conf struct {
	Meta      meta.Mutate
	Object    *corev1.PersistentVolumeClaim
	Reconcile interfaces.Reconcile
	GenPVCFunc
	StorageClassName *string
	GenResourcesFunc
	GenAccessModesFunc
}

type Mutate interface {
	MutateFunc() controllerutil.MutateFn
}

//func (c Conf) MutateFuncs() []controllerutil.MutateFn {
//	var funcs []controllerutil.MutateFn
//	if c.GenResourcesFunc != nil {
//		funcs = append(funcs, c.GenResourcesFunc)
//	}
//	if c.GenAccessModesFunc != nil {
//		funcs = append(funcs, c.GenResourcesFunc)
//	}
//	return funcs
//}

// func MutateFn(m Mutate) controllerutil.MutateFn {
//	funcs := m.MutateFuncs()
//	for _, f := range funcs {
//		if err := f(); err != nil {
//			return func() error {
//				return err
//			}
//		}
//	}
//	return func() error {
//		return nil
//	}
//}
